    !     ####################################################################################################
    !     this is one of several source files for the marssim landform evolution model
    !     copyright (c) 2009 alan d. howard
    !     developer can be contacted by ah6p`virginia.edu and department of environmental sciences, p.o. box 400123,
    !                university of virginia, charlottesville, va 22904-4123
    !     this program is free software; you can redistribute it and/or modify it under the terms of the gnu general public license
    !       as published by the free software foundation; either version 2 of the
    !       license, or (at your option) any later version.
    !     this program is distributed in the hope that it will be useful, but without any warranty;
    !        without even the implied warranty of merchantability or fitness for a particular purpose. see the gnu
    !        general public license for more details.
    !      you should have received a copy of the gnu general public license along with this program; if not, write to
    !        the free software foundation, inc., 51 franklin street, fifth floor, boston, ma 02110-1301 usa.
    !        a web link:   http://www.gnu.org/licenses/gpl-2.0.txt
    !     ####################################################################################################

    !      ********************************************
    !          Include file for basin erosion program
    !              defines global variables
    !      ********************************************
    MODULE ERODE_GLOBALS
        IMPLICIT NONE
        SAVE
        !         immx and jmmx are the maximum x and y size of the simulation
        !         lmmx should equal immx*jmmx
        INTEGER(4) :: IMMX,JMMX,LMMX,RMMX
        REAL(8) ::  CUT_RATIO,BIAS_PARAMETER
        REAL(8) ::  SECONDS_PER_YEAR,SEDSETTLE,WATER_DENSITY,SKLAR_FACTOR
        PARAMETER (CUT_RATIO=0.001)
        PARAMETER (BIAS_PARAMETER=0.2)
        PARAMETER (SECONDS_PER_YEAR=31.536E+6,SEDSETTLE=0.66667)
        PARAMETER (WATER_DENSITY=1000.0)
        PARAMETER (SKLAR_FACTOR=4.0E-09)
        INTEGER(4) :: INDATA,PARAMS,INRESIST,OUTDATA,OUTHIST,OUTCHAN
        INTEGER(4) :: DOWNSTREAM(9,2),OUTRECORD,OUTSUMMARY,WRITE_CHANGE_INTERVAL
        INTEGER(4) :: MX,MY,MZ,OUTSOURCE,OUTREPORT,OUTDEFORM
        INTEGER(4) :: IABORTMAX,IABORTMIN,JABORTMAX,JABORTMIN
        INTEGER(4) :: MP,EVENT_INDEX,NUMBER_OF_EVENTS
        INTEGER(4) :: IDUMMY,ICLAST,JCLAST
        INTEGER(4) :: MAXIMUM_ITERATION,ELEVATION_PRINT_INTERVAL,OUTPUT_PRINT_INTERVAL,RECALCULATE_GRADIENT_INTERVAL
        INTEGER(4) :: CRITICAL_GRADIENT_USE,ITERATION,WRITETYPE(13)
        INTEGER(4) :: ONEONLY,STARTING_ITERATION,TOTAL_ITERATIONS
        INTEGER(4) :: LAYERUSE,SLOPEVARUSE,CHANNELVARUSE
        INTEGER(4) :: NCRITS,NMAX,LMAX,NEWERODE,KWRITE,RANDDISCHUSE
        INTEGER(4) :: TOTAL_BASINS,EVENT_TYPE,EVENT_ITERATIONS(20)
        INTEGER(4) :: IWINLOW,IWINHIGH,JWINLOW,JWINHIGH,WATERUSE
        INTEGER(4) :: ICENT,JCENT,INRATES,PARAMETER_CHANGE_INDEX,NUMBER_OF_PARAMETER_CHANGES
        INTEGER(4) :: OUTIMGDAT,IMAGE_OUTPUT_INTERVAL,OUTROCK,OUTHIGH
        INTEGER(4) :: DIVERGEINTERVAL,MYY,OUTREGOLITH,OUTLAKE
        INTEGER(4) :: ILOWEST,JLOWEST,INUMLEVELS,IDET,JDET
        INTEGER(2) ::  IFILE1,IFILE2,IFILE3,XFILE1,XFILE2,XFILE3
        INTEGER(4) :: OUTRESIST,OUTGRAD,OUTALLUV,OUTEROSION_DEPTH_INDEX,OUTCONT
        INTEGER(4) :: OUTELEV,IOTEMP1,IOTEMP2,OUTBASE,OUTCRATER
        INTEGER(4) :: IDEBUG(500),JDEBUG(500),IJDEBUG,NCALCEVAP
        INTEGER(4) :: I_INFLUENT_RIVER(10),J_INFLUENT_RIVER(10),NUMBER_OF_INFLUENT_RIVERS
        INTEGER(4) ::  ISEED,NCHANGEEVAP
        INTEGER(4) :: ICASE(20)
        REAL(8) ::  DISCHARGE_CONSTANT,DISCHARGE_EXPONENT, TRANSPORTFACTOR,MANNING,CONVERT_TO_METERS
        REAL(8) ::  SEDIMENT_POROSITY,SEDIMENT_SPECIFIC_GRAVITY,GRAVITY,INPUT_CELL_SIZE,VERTICAL_SCALING_FACTOR
        REAL(8) ::  TIMES_FOR_PARAMETER_CHANGES(50),EROSION_RATE_VALUES(50),ELOWEST
        REAL(8) ::  DEFAULT_CHANNEL_TIMESTEP,FLOW_FRACTION,GRAIN_SIZE,REGOLITH_ERODIBILITY_FACTOR
        REAL(8) ::  SQRTOFTWO,XSEED,ISEED1,SLOPE_FAILURE_DIFFUSIVITY,GRADMAX,FAILMAX
        REAL(8) ::  RATECAT(102),GRADCAT(102),DELRATE(102),D2X
        REAL(8) ::  BOUNDARY_LOWERING_RATE,BEDROCK_DISCHARGE_EXPONENT,BEDROCK_GRADIENT_EXPONENT
        REAL (8) :: SLOPE_DIFFUSIVITY,BEDROCK_ERODIBILITY
        REAL(8) ::  DETACHMENT_CRITICAL_SHEAR,CRITICAL_SLOPE_GRADIENT,SLOPE_GRADIENT_EXPONENT,TIME_INCREMENT,PRESENT_TIME
        REAL(8) ::  CHANNEL_TIMESTEP_SCALING,MAXIMUM_ELEVATION_CHANGE,GRADAVERAGE,MAXGRADIENT,TMULT
        REAL(8) ::  NEWBASE,MAXIMUM_DIFFUSIVITY_INCREASE,CRITICAL_SOURCE_DIVERGENCE,CRITICAL_GRADIENT_TERM
        REAL(8) ::  MAXIMUM_CHANNEL_TIMESTEP,NUMBIDCHANGE,SUMGRADCHANGE,ABSGRADCHANGE
        REAL(8) ::  CHANGECOUNT,DELTA_FORESET_GRADIENT,DISCHARGE_COEFFICIENT,BISTABLE_RUNOFF_FACTOR
        REAL(8) ::  DIFFUSIVITY_VARIABILITY,SIMULATION_PARAMETERS(50,20)
        REAL(8) ::  SURFACE_LAYER_RESISTANCE,LAYERMAX,LAYERMIN,SEDIMENT_DISCHARGE_FACTOR
        REAL(8) ::  CROSS_WEIGHTING,DIAGONAL_WEIGHTING,MAXCRIT,FLEN(9),ONE_SIXTH
        REAL(8) ::  AREAFACTOR,HYDRAULIC_CONDUCTIVITY,EVAPORATION_MEAN,EVAPORATION_STANDARD_DEVIATION,EVAPORATION_SCALE
        REAL(8) ::  CHANNEL_WIDTH_CONSTANT,CHANNEL_WIDTH_EXPONENT,DISCHARGE_COEFF_VARIATION,MINUMUM_TIME_INCREMENT
        REAL(8) ::  SEDIMENT_1_EXPONENT,SEDIMENT_2_EXPONENT,SEDIMENT_GRADIENT_EXPONENT,SEDIMENT_CONSTANT
        REAL(8) ::  TRANSPORT_CRITICAL_DIM_SHEAR,SEDIMENT_TRANSPORT_EXPONENT,CRITICAL_SHEAR_VARIABILITY
        REAL(8) ::  TEMPQCONSTANT,LASTQCONSTANT
        REAL(8) ::  OCEANNEXTTIME,EVAPORATION_RATE
        REAL(8) ::  OCEANTSLOPE,OCEANTINT,MAXIMUM_SIMULATION_TIME
        REAL(8) ::  SEDIMENT_TIMESTEP_SCALING,MASS_WASTING_TIMESTEP_SCALING,TIMECHANGE
        REAL(8) ::  ROUTETHRSHLD,OCEAN_ELEVATION,ALVCREEPFAC,DEPRESSFAC
        REAL(8) ::  STICKYFACTOR,STICKY_ROUTING_CRITICAL_VALUE,STICKYPROB(11),STICKYCAT(11)
        REAL(8) ::  EROSION_RATE_CHANGE_LAG,BISTABLE_CRITICAL_SHEAR,DISCHFACT,HIGH_EROSION_THRESHOLD
        REAL(8) ::  ROCK_WEATHERING_RATE,CRITICAL_BEDROCK_GRADIENT,RGRADMAX,STICKYDEL(11)
        REAL(8) ::  RDELRATE(102),RGRADCAT(102),RRATECAT(102),REGOLITH_CRITICAL_SHEAR_FACTOR
        REAL(8) ::  WEATHER_DIVERGENCE,WEATHER_DECAY_RATE,OMEGA_WEIGHT
        REAL(8) ::  OCORRECT,PREVIOUS_DISCHARGE_COEFFICIENT,PREVIOUS_CRITICAL_SHEAR
        REAL(8) ::  EREFERENCE,VERTICAL_RESISTANCE_SCALING,RANDMULT,SIGMANORM,SIGMASQ
        REAL(8) ::  WEATHERING_DECAY_2,WEATHERING_TERM_2,RUNOFF_CONSTANT_1,RUNOFF_CONSTANT_2
        REAL(8) :: RUNOFF_CONSTANT_3,MEAN_CONVERGENCE_RUNOFF
        REAL(8) ::  DEFORMSCALE,BISTABLE_BEDROCK_ERODIBILITY,CELL_SIZE,WEIGHTS(2,2,4)
        REAL(8) ::  SURFACE_LAYER_THICKNESS,GRADCUT,CUMULEXCESS,LAST_TIME_INCREMENT
        REAL(8) ::  EOLIAN_EVENT_PROBABILITY,LAVA_EVENT_PROBABILITY,IMPACT_PROBABILITY,MAXIMUM_TIME_INCREMENT
        REAL(8) ::  RAINDEPTH,RAINSTD,LOW_EROSION_THRESHOLD
        REAL(8) ::  DEPOSITWORK,ERODEWORK,CRATERWORK,LAVAWORK,LAVADEPTH
        REAL(8) ::  EOLIANDEPTH,ELAPSEDTIME,ERODETOADD,SLOPETOADD
        REAL(8) ::  INITIAL_REGOLITH_THICKNESS,SLOPEWORK,SLGRAVTOADD
        REAL(8) ::  PREVIOUS_TIME_INCREMENT,BEDLOAD_FRACTION,EFFECTIVE_DISCHARGE_RATIO
        REAL(8) ::  INFLUENT_RIVER_DISCHARGE(10),INFLUENT_RIVER_SEDIMENT_LOAD(10)
        REAL(8) ::   DEPOSITGRAV,ERODEGRAV,CRATERGRAV,ERGRAVTOADD
        REAL(8) ::   SLOPEGRAV,VERTICAL_SCALING,ROCK_TENSILE_STRENGTH,GROUNDWATER_SCALE_FACTOR
        REAL(8) ::  SEDBIAS,LASTSEDBIAS,SKLAR_MULT,EPOWER
        REAL(8) ::  VEGETATION_UPLAND_RESISTANCE,VEGETATION_CHANNEL_RESISTANCE
        REAL(8) :: VEGETATION_AREA_MINIMUM,VEGETATION_AREA_MAXIMUM,VEGETATION_FACTOR_SLOPE
        REAL(8) ::  VEGETATION_FACTOR_INTERCEPT,MAXIMUMELEVATION,EVENT_TIMES(10)
        REAL(8) ::  SEEPAGE_WEATHERING_SCALING,SEEPAGE_WEATHERING_EXPONENT,DISCHARGE_SCALE_FACTOR
        REAL(8) ::  WASHLOAD_FRACTION,PELAGICCREEP,WEATHER_MULT
        REAL(8) ::  AVGRUNOFF,AVGSEEP,AVGSEEPFRACT,NSEEPAVG,NFRACTAVG
        REAL(8) ::  DEPOSITFRACTION,STEADY_DISCHARGE_FACTOR
        LOGICAL(4) ::  DONE,WRITE_ABSOLUTE_ELEVATION,USE_CRITICAL_SLOPE_CRADIENT,ABORT_SIMULATION,NO_LAKES_EXIST
        LOGICAL(4) ::  USELAYER,USE_3D_SLOPE_RESISTANCE
        LOGICAL(4) ::  WRITE_OUT_CHANNELS,USEBEDRILL,LDUMMY,DO_DEBUGGING
        LOGICAL(4) ::  DO_SEDIMENT_TRANSPORT,DO_SEDIMENT_DIFFUSION,DO_SEDIMENT_ROUTING,COMPLETE_RUNOFF,DO_MODEL_SLOPES
        LOGICAL(4) ::  DO_MORPHOMETRY,USE_AN_OCEAN,DO_DEMON_FLOW_ROUTING,USE_RANDOM_FLOWROUTING,STICKY_SEDIMENT_ROUTING
        LOGICAL(4) ::  VARIABLE_EROSION_RATE,RANDOM_CRITICAL_SHEAR,USE_RANDOM_DISCHARGE,BISTABLE_FLUVIAL_EROSION
        LOGICAL(4) ::  TWO_TERM_WEATHERING,DIVERGENCE_DEPENDENT_RUNOFF,NEW_SIMULATION
        LOGICAL(4) ::  DO_ROCK_DEFORMATION,SCALE_3D_ROCK_ERODIBILITY,NO_FLUX_LOWER_BOUNDARY,HORIZONTAL_LOWER_BOUNDARY
        LOGICAL(4) ::  NON_ERODING_LOWER_BOUNDARY,USE_BISTABLE_BEDROCK,IS_Y_PERIODIC,RESISTANT_SURFACE_LAYER
        LOGICAL(4) ::  EXPLICIT_CHANNEL_BED_STATE,DO_ALLUVIAL_SMOOTHING,DO_ALLUVIAL_REROUTING
        LOGICAL(4) ::  MODEL_LAVA_FLOWS,MODEL_IMPACT_CRATERING,MODEL_EOLIAN_CHANGES,FLUVIAL_AND_SLOPE_MODELING,DO_FLUVIAL_DETACHMENT
        LOGICAL(4) ::  ROUTE_REGOLITH_OVER_ROCK,WRITE_SEDIMENT_DIAGNOSTICS,SEDSWITCH
        LOGICAL(4) ::  VARIABLE_OCEAN_ELEVATION,HAVE_INFLUENT_RIVERS
        LOGICAL(4) ::  MODEL_OCEAN_LEVEL,DISCHARGE_WEATHERING
        LOGICAL(4) ::  USE_ROERING_MASS_WASTING,USE_SKLAR_BED_ABRASION,USE_WHIPPLE_BED_ABRASION
        LOGICAL(4) ::  MODEL_ACCRETION_AND_ABLATION,USE_TOTAL_EXPOSURE
        LOGICAL(4) :: IS_X_PERIODIC,FORCE_SEDIMENT_CONSERVATION,RESCALE_DISCHARGES
        LOGICAL(4) :: PERMEABILITY_RESCALING,DEFAULT_EOLIAN_PROCESS,SEEPAGE_WEATHERING,MODEL_LAKE_EVAPORATION
        LOGICAL(4) :: MODEL_PELAGIC_DEPOSITION,DO_FLOW_BOUNDARIES
        !      parameters for groundwater flow and sapping
        LOGICAL(4) ::  SHOW_GROUNDWATER_CALCULATIONS
        LOGICAL(4) ::  USE_GROUNDWATER_FLOW,MODEL_GROUNDWATER,SEEPAGE_AVERAGING,USEIMPLICIT
        LOGICAL(4) ::  EXPONENTIAL_PERMEABILITY_DECAY
        LOGICAL(4) ::  VARIABLE_VEGETATION_RESISTANCE, EVENT_DONE(10),DO_EVENTS
        REAL(8) ::  GROUNDWATER_DEPTH_SCALE,MAXIMUM_GOUNDWATER_ERROR,GROUNDWATER_RECHARGE_RATE
        REAL(8) ::  GROUNDWATER_FLOW_FRACTION,CONVERT_DISCHARGE,GROUNDWATER_RELAXATION_CONST
        REAL(8) :: ALLUVIUM_SMOOTHING_FACTOR,INITIAL_GROUNDWATER_DEPTH
        INTEGER(4) :: MAXIMUM_GROUNDWATER_ITERATIONS ,SEEPAGE_ITERATION_INTERVAL,OUTSEDDEBUG
        !      end parameters for groundwater flow and sapping
        CHARACTER (LEN=6) :: RPREFIX
        CHARACTER (LEN=4) :: X1PREFIX, X2PREFIX , X3PREFIX, RSUFFIX
        CHARACTER (LEN=30):: X1FILENAME ,X2FILENAME ,X3FILENAME
        CHARACTER (LEN=1) :: XNUM1 ,XNUM2, XNUM3, RNUM3,RNUM2, RNUM1
        CHARACTER (LEN=7) :: XDIRECT
        CHARACTER (LEN=25) :: RFILENAME
        REAL(8),ALLOCATABLE, DIMENSION(:) :: BASIN_DRAINAGE_AREA,LAKE_OUTLET_ELEVATION
        REAL(8),ALLOCATABLE, DIMENSION(:) :: LAKE_SURFACE_ELEVATION,SORTING_VECTOR
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: ELEVATION,D8_GRADIENT,ERODE_CHANNEL,ERODE_SLOPE
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: RELATIVE_RESISTANCE,CFW,CFN,CFNE,CFNW
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: CHANNEL_WIDTH,SEDIMENT_BASE,SEDIMENT_YIELD
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: SEDIMENT_FLUX,EQUILIBRIUM_GRADIENT,DRAINAGE_AREA
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: CUMULATIVE_ELEVATION_CHANGE,NOMINAL_ERODE_SLOPE
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: CUMULATIVE_EOLIAN_CHANGE,CUMULATIVE_LAVA_CHANGE
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: CUMULATIVE_CRATERING_CHANGE,MAXIMUM_SEDIMENT_YIELD
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: PREVIOUS_ELEVATION,DISCHARGE,MAXIMUM_DISCHARGE,INITIAL_ELEVATION
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: DIVERGENCE,ERODE_REGOLITH_CHANNEL
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: REGOLITH,DEFORMATION
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: FILTERED_GROUNDWATER_FLUX,TRANSMISSIVITY_TERM
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: WATER_ELEVATION,GROUNDWATER_FLUX
        REAL(8),ALLOCATABLE, DIMENSION(:) :: OCEAN_RECALCULATION_TIMES, OCEAN_LEVELS
        REAL(8),ALLOCATABLE, DIMENSION(:) :: PELAGIC_SEDIMENT_VOLUME
        REAL(8),ALLOCATABLE, DIMENSION(:,:) :: PELAGICCHANGE,PELAGICEDIFF
        INTEGER(4),ALLOCATABLE, DIMENSION(:) :: I_OUTFLOW,J_OUTFLOW,DOWNSTREAM_BASIN
        INTEGER(4),ALLOCATABLE, DIMENSION(:,:) :: BASIN_NUMBER,FLOW_DIRECTION,IDO,EROSION_DEPTH_INDEX
        LOGICAL(4),ALLOCATABLE, DIMENSION(:) :: ENCLOSED,OVERFLOWS
        LOGICAL(4),ALLOCATABLE, DIMENSION(:,:) :: IS_SEDIMENT_COVERED,SUBMERGED
        LOGICAL(4),ALLOCATABLE, DIMENSION(:,:) :: ACCELERATED_EROSION,DO_ACCELERATED_EROSION,IS_ROCK_SURFACE
        LOGICAL(4),ALLOCATABLE, DIMENSION(:,:) :: SEDIMENT_DEPOSITED,IS_INFLUENT_RIVER_LOCATION
        LOGICAL(4),ALLOCATABLE, DIMENSION(:,:) :: FIXED_HEAD
        LOGICAL(4),ALLOCATABLE, DIMENSION(:) :: ERODING_LOWER_BOUNDARY,IS_EXIT_BASIN
    END MODULE ERODE_GLOBALS
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODULE LAVA_GLOBALS
        IMPLICIT NONE
        SAVE
        !      ********************************************
        !          Include file for lava flow program
        !              defines global variables
        !      ********************************************
        INTEGER(4) ::  NUMBER_OF_ACTIVE_LAVA_CELLS,ISTART,JSTART
        INTEGER(4) :: LAVAMAXITER,LAVAITER
        INTEGER(4) :: NEW_SEGMENT_INTERVAL,IBACK(9),SOURCECOUNT
        INTEGER(4) :: NUMBER_OF_LAVA_SOURCES,I_LAVA(100),J_LAVA(100)
        INTEGER(4) :: SOURCE_CHANGE_INTERVAL
        INTEGER(4) :: ICONTINUE
        LOGICAL(1),ALLOCATABLE, DIMENSION(:,:) :: IS_LAVA_COVERED,ACTIVE_LAVA_FLOW
        INTEGER(4),ALLOCATABLE, DIMENSION(:,:) :: LAVA_SOURCE_DIRECTION,ERUPTION_AGE
        REAL(8), ALLOCATABLE, DIMENSION(:) :: LAVA_THICKNESS
        REAL(8), ALLOCATABLE, DIMENSION(:,:) :: LAVA_FLOW_PROBABILITY
        INTEGER(4), ALLOCATABLE, DIMENSION(:) :: LAVA_ELAPSED_TIME,ILOC,JLOC
        REAL(8) :: LAVA_DURATION_WEIGHT,LAVA_GRADIENT_WEIGHT,EOLD
        REAL(8) :: MINIMUM_LAVA_FLOW_SLOPE,ERUPTION_STOP_PROBABILITY,LAVA_FLOW_THICKNESS
        REAL(8) :: NO_FLOW_PROBABILITY,TLACTIVESUM,TLACTIVESQ,TACTSAMP
        REAL(8) :: TVOLUMESUM,TVOLUMESQ,TVOLUMESAMP,MINIMUM_FLOW_THICKNESS
    END MODULE LAVA_GLOBALS
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODULE CRATER_GLOBALS
        IMPLICIT NONE
        SAVE
        INTEGER(4) :: KSIZE
        INTEGER(4) :: TOPFILE,SHADEFILE,BASEFILE
        INTEGER(4) :: NIMPACTS,ITERNO,ITOTHITS,DIFFINTERVAL
        INTEGER(4) :: NOISEINTERVAL
        REAL(8) :: CRATER_FREQUENCY_EXPONENT,ALINV,SMALLEST_MODELED_CRATER,LARGEST_MODELED_CRATER,CCON,BCON
        INTEGER(4) :: IMIN,IMAX,JMIN,JMAX,RCATS(10),OCATS(10)
        INTEGER(4) :: COUNT2,COUNT10
        INTEGER(4) :: IMINR,IMAXR,JMINR,JMAXR
        REAL(8) :: DIAMETER,XMIN,YMIN,XMAX,YMAX,XCENTER,YCENTER
        REAL(8) :: CRATER_DEPTH,RIM_HEIGHT,INTERIOR_SHAPE_EXPONENT,EXTERIOR_SHAPE_EXPONENT
        REAL(8) :: RADIUS,MAXRANGE,ELEVBASE,SMALLEST_POSSIBLE_CRATER
        REAL(8) :: EJECTA_THICKNESS_VARIABILITY,NOISESD,INHERITANCE_PARAMETER,FREQUENCY_CUTOFF_SCALING
        REAL(8) :: DCATS(10),LARGE_CRATER_DEPTH_SCALE,LARGE_CRATER_DEPTH_EXPONENT
        REAL(8) :: LARGE_CRATER_RIM_SCALE,LARGE_CRATER_RIM_EXPONENT,INITGRAD
        REAL(8) :: SMALL_CRATER_DEPTH_SCALE,SMALL_CRATER_DEPTH_EXPONENT,SMALL_CRATER_RIM_SCALE,SMALL_CRATER_RIM_EXPONENT
        REAL(8) :: SMALL_CRATER_SHAPE_SCALE,SMALL_CRATER_SHAPE_EXPONENT,LARGE_CRATER_SHAPE_SCALE,LARGE_CRATER_SHAPE_EXPONENT
        REAL(8) :: SIZES(1000),XLOCS(1000),YLOCS(1000),TRANSITION_DIAMETER
        REAL(8) :: MAXIMUM_RIM_GRADIENT
        LOGICAL(4) :: RANDOM_EJECTA_THICKNESS,MICRONOISE,NOISECALL,DIFFUSECALL
        LOGICAL(4) :: DO_EJECTA_WRAPAROUND, IS_REGOLITH_CRATER
    END MODULE CRATER_GLOBALS
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODULE LAKE_GLOBALS
        IMPLICIT NONE
        SAVE
        REAL(8), ALLOCATABLE, DIMENSION(:,:) :: ROUTED_DISCHARGE
        REAL(8), ALLOCATABLE, DIMENSION(:) :: LAKE_AREA,LAKE_VOLUME
        REAL(8), ALLOCATABLE, DIMENSION(:) :: LOWEST_LAKE_ELEVATION,NEW_BASIN_OUTFLUX,BASIN_INFLUX
        REAL(8), ALLOCATABLE, DIMENSION(:) :: BASIN_OUTFLUX,OLDOVERFLOWS
        REAL(8), ALLOCATABLE, DIMENSION(:) :: LAKEMIN,BASINMIN
        LOGICAL(1), ALLOCATABLE,DIMENSION(:) :: NEXTCYCLE,NEWGEOMETRY
        LOGICAL(1), ALLOCATABLE,DIMENSION(:) :: ISBORDER
    END MODULE LAKE_GLOBALS
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODULE EOLIAN_GLOBALS
        IMPLICIT NONE
        SAVE
        REAL(8) :: ZERO_PERCENT_EXPOSURE,EXPOSURE_50_PERCENT,EXPOSURE_90_PERCENT
        REAL(8) :: MINIMUM_EOLIAN_DEPOSIT_RATE,MAXIMUM_EOLIAN_DEPOSIT_RATE
        REAL(8) :: EXPOSURE_10_PERCENT,DEPOSITRATE
        REAL(8) :: EOLIAN_CONSTANT_1,EOLIAN_CONSTANT_2,EOLIAN_CONSTANT_3
        REAL(8) :: DISTANCE_DECAY_FACTOR,WEIGHTING_DECAY_FACTOR,RATE0
        INTEGER(4) :: NITER,NPRINT,MAXIMUM_WEIGHT_DISTANCE,WEIGHTING_CALCULATION_DISTANCE,ICNNT,JCNNT
        REAL(8) :: EOLIAN_TIME_INCREMENT,WEIGHTX(350),WEIGHTD(350)
        REAL(8) :: MAXWEATHERRATE
        REAL(8) :: DISTANCE_WEIGHTING(51,51),DISTANCE_VALUE(51,51)
    END MODULE EOLIAN_GLOBALS
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODULE OCEAN_GLOBALS
        IMPLICIT NONE
        SAVE
        REAL(8),ALLOCATABLE,DIMENSION(:,:) :: ELL2,FLUX_X,FLUX_Y
        LOGICAL(4),ALLOCATABLE,DIMENSION(:,:) :: TURB
        REAL(8), PARAMETER :: D=1.0
        REAL(8), PARAMETER :: DL=5.0
    END MODULE OCEAN_GLOBALS
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODULE SEDROUTE_GLOBALS
        IMPLICIT NONE
        SAVE
        REAL(8) :: DEFAULT_DRAINAGE_AREA,DEFAULT_SEDIMENT_YIELD,SEDIMENT_CARRYOVER
        INTEGER(4) :: ISTART,JSTART,IEND,JEND,INOW,JNOW,IDX
        INTEGER(4) :: K,IABCD,IXT,JYT,IIII,JDY,IXX,JYY
        INTEGER(4) :: INCRX,INCRY,EE,INC1,INC2,IDMAX,ICOUNT
        LOGICAL(4) :: IS_DEPRESSION,IS_THERE,MUST_SEARCH,DO_BACKTRACK
        LOGICAL(4), ALLOCATABLE,DIMENSION(:,:) :: DONE_ONCE
        INTEGER(4), ALLOCATABLE,DIMENSION(:) :: I_LOCATION,J_LOCATION
    END MODULE SEDROUTE_GLOBALS
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODULE SEDDEBUG_GLOBALS
        IMPLICIT NONE
        SAVE
        REAL(8) :: UPSTREAM_ELEVATION,ACTUAL_START_GRADIENT,ALLUVIAL_START_GRADIENT,SEDIMENT_VOLUME,PROVISIONAL_START_GRADIENT
        REAL(8) :: PROVISIONAL_END_GRADIENT,EL1,EL2,START_STEP_DISTANCE,MAXCHG,END_ELEVATION
        INTEGER(4) :: KKK,I_NEW,J_NEW,I_OLD,J_OLD,IMAX,JMAX
        REAL(8), ALLOCATABLE, DIMENSION(:) :: STARTING_ELEVATION,ALLUVIAL_GRADIENT,ACTUAL_GRADIENT
        REAL(8), ALLOCATABLE, DIMENSION(:) :: STEP_DISTANCE,NEW_ELEVATION,PROVISIONAL_ELEVATION,WATER_LEVEL
        LOGICAL(4) , ALLOCATABLE, DIMENSION(:) :: IS_BEDROCK_CHANNEL
    END MODULE SEDDEBUG_GLOBALS
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODULE AREA_GLOBALS
        IMPLICIT NONE
        SAVE
        REAL(8), ALLOCATABLE, DIMENSION(:) :: TOBEADDED,LOCAL_BASIN_DISCHARGE,QTOADD
        LOGICAL(4), ALLOCATABLE, DIMENSION(:) :: NEEDTODO,OUTER
    END MODULE AREA_GLOBALS
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        !     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODULE ACCRETION_GLOBALS
        IMPLICIT NONE
        SAVE
        LOGICAL :: USE_INVERSE_EXPOSURE, EXPOSURE_DEPENDENT_CREEP, USE_EXPOSURE_SMOOTHING,USE_SOLAR_EROSION,USE_TOP_EXPOSURE
        REAL (8) :: RAD_CONST, RAD_DUST_FACTOR,RAD_THRESH_CONVEXITY,RAD_DEPOSIT_RATE,ACCRETION_RATE,TOTALRADERODE
        REAL(8), ALLOCATABLE, DIMENSION(:,:) :: EXPOSE_RATE,SMOOTH_EXPOSE
    END MODULE ACCRETION_GLOBALS



